open Msh_ast


let parse_inputunit lb =
  Msh_parser.inputunit Msh_lexer.token lb

let print_prompt () =
  print_string "--> ";
  flush stdout

let step lb =
  print_prompt ();
  let cmd = parse_inputunit lb in
(*   Msh_printer.print cmd; *)
  let n = Msh_evaluator.eval_cmd cmd in
  (* Format.eprintf "@.exit %n@." n *)
  ignore n


let main =
  let lb = Lexing.from_channel stdin in
  while true do
    try step lb with
    | Msh_lexer.Lexical_error s ->
	flush stdout;
	Format.eprintf "lexical error: %s\n@." s
    | Parsing.Parse_error ->
	flush stdout;
	Format.eprintf "syntax error\n@."
    | Unix.Unix_error(err, f, arg) ->
	Format.printf "%s %s: %s@." f arg (Unix.error_message err)
    | e ->
	Format.eprintf "error: %s\n@." (Printexc.to_string e)
  done
